#---------------------------------------
set privconf "/glftpd.priv"
set mainlog "/ftp-data/logs/glftpd.log"
set dupelog "/ftp-data/logs/dupelog"
set userpath "/ftp-data/users"
set passwd "/etc/passwd"
set admingrp "STAFF"


#---------------------------------------
set glcver "0.1"
#--------------------------------------- begin code.

proc ardw {filename {wbuf ""}} {
	set of "1" ; set llist ""
	if [file exists $filename] {
		if [catch {open $filename r+} of] {set wbuf "" ; return "e"}
	} else {
		if [catch {open $filename w} of] {set wbuf "" ; return "e"}
	}
	if {$wbuf == ""} {
		set size [file size $filename]
		if {$size > 1} {set llist [read $of $size]}
	} else { 
		seek $of 0 ; catch {foreach line $wbuf {puts $of "$line"}} msg
		set wbuf ""
	}
	close $of
	return $llist
}

proc uidr {} {
  global passwd
  set uidtab ""
  foreach line [split [ardw $passwd] \n] {
	set line [split $line :]
	lappend uidtab [lindex $line 2] [lindex $line 0]
  }
  return $uidtab
}

proc fragr {path {mode 0}} {
  global privconf
  set wbuf "" ; set patha "$path/*"
  set lines [ardw $privconf]
  if {$lines == "e"} {puts "ERROR failed to load configuration $privconf\n" ; return -code return}
  if {$mode == 0} {
### return all lines without specified path 
     foreach line [split $lines \n] {
	set line [string trim $line]
	if {$line == "" || [string equal -length 1 "#" $line]} {continue}
	if {[lsearch $line $path] == -1 && [lsearch $line $patha] == -1} {lappend wbuf $line}
     }
  } else {
### return any lines with specified path 
     foreach line [split $lines \n] {
	set line [string trim $line]
	if {$line == "" || [string equal -length 1 "#" $line]} {continue}
	if {[lsearch $line $path] != -1 || [lsearch $line $patha] != -1} {lappend wbuf $line}
     }
  }
  return $wbuf
}


proc fragw {path group} {
  global privconf admingrp
  set lines [fragr $path] ; set patha "$path/*"
  if [string equal "e" $lines] {set lines ""}
  lappend lines "privpath $path =$group =$admingrp"
  lappend lines "hideinwho $patha *"
  lappend lines "creditloss 0 yes $patha *"
  lappend lines "nodupecheck $patha"
  lappend lines "creditcheck $patha 0"
  lappend lines "nostats $patha *"
  lappend lines "upload $patha =$group =$admingrp"
  lappend lines "delete $patha =$group =$admingrp"
  lappend lines "rename $patha =$group =$admingrp"
  if {[ardw $privconf $lines] == "e"} {return 0}
  return 1
}

proc fragd {path} {
  global privconf
  set lines [fragr $path]
  catch {file delete -force $privconf}
  if {[ardw $privconf $lines] == "e"} {return 0}
  return 1
}

proc preprep {path} {
  catch {file mkdir $path}
  if [file exists $path] {
	file attributes $path -permissions rwxrwxrwx
	return 1
  } else {
	return 0
  }
}

proc predirchk {dir} {
  global prepaths
  set prepaths [fragr privpath 1]
  if {$prepaths != ""} {
    foreach line $prepaths {
      if [string match "[lindex $line 1]/*" $dir] {
        return [string trim [lindex $line 2] =]
      }
    }
  }
  return 0
}


